import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


public class PowerComboExtract {


    /**These routines extract the data for our tests*/
    

    /**This is the data for the small0 (Lemmas 221,222,231,222) calculations.
       The data is contained in the file Data*/
    
    public static PowerCombo extract(long[] data) {
	PowerCombo A= new PowerCombo();
	A.COUNT=6;
	for(int i=0;i<6;++i) A.c[i]=new BigRational(data[i],1);
	A.b[0]=new BigRational("1","2");
	A.b[1]=new BigRational("1","3");
	A.b[2]=new BigRational("1","4");
	A.b[3]=new BigRational("1","2");
	A.b[4]=new BigRational("1","3");
	A.b[5]=new BigRational("1","4");
	for(int i=0;i<3;++i) {
	    A.t[i]=0;
	    A.t[3+i]=1;
	}
	A.L=new BigRational("0","1");
	A.R=new BigRational("0","1");
	return A;
    }



    /**Here is the power combo for the big (Lemma A233) calculation*/

    public static PowerCombo extractBig(int k0) {
	String[] Q=new String[9];
	int k=9*k0;
	for(int i=0;i<9;++i) Q[i]=new String(Data2.dataBig(k+i));
	return(extract(Q));
    }

    public static PowerCombo extractSmall(int k0) {
	String[] Q=new String[9];
	int k=9*k0;
	for(int i=0;i<9;++i) Q[i]=new String(Data2.dataSmall(k+i));
	return(extract(Q));
    }


    

    /**This uses a string of length 9
       ("a00","a01","a02","a10",...,"a22") 
        to make a power combo.
       The power combo has the form

      (a00 + a01 s + a02 s^2) 3^(s/2)+ 
      (a10 + a11 s + a12 s^2) 4^(s/2)+ 
      (a20 + a21 s + a22 s^2) 6^(s/2)

      I save these numbers as strings because
      some of them are too big to be "longs"*/


    public static PowerCombo extract(String[] Q) {
	PowerCombo A=new PowerCombo();
	A.COUNT=9;
	
	for(int i=0;i<3;++i) {
	    A.b[i+0]=new BigRational("3","1");
	    A.b[i+3]=new BigRational("4","1");
	    A.b[i+6]=new BigRational("6","1");
	}

	for(int i=0;i<3;++i) {
	    A.t[3*i+0]=0;
	    A.t[3*i+1]=1;
	    A.t[3*i+2]=2;
	}

	for(int i=0;i<9;++i) {
	    A.c[i]=new BigRational(Q[i],"1");
	}

	
	A.L=new BigRational("6","1");
	A.R=new BigRational("16","1");
	return A;
    }


    


}



