import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

/**This tests the difference in energy before and after the 
   chosen symmetrization operation.  As the program runs, it
   computes the minimimum energy change over many trials and
   reports the answer every million trials.  The symmetrization
   operation is good this minimum remains positive.*/

public class SymmetrizeTester implements Runnable {
    boolean HALT;
    Manager M;

    public SymmetrizeTester() {
	HALT=true;
    }
    public SymmetrizeTester(Manager m) {
	M=m;
	HALT=true;
    }


    public void run() {
	M.P.COUNT=0;
	HALT=false;
	int[] b=new int[16];
	double[] min={100,100,100,100,100};
	long count=0;
	long count2=0;
	while(HALT==false) {

	    double[] test=doTest();

	   if(count==1000000) {
                 System.out.println(count2+" million: min="+min[0]+" "+min[1]+" "+min[2]+" "+min[3]+" "+min[4]);
		 count=0;
		 ++count2;
		 M.P.COUNT=count2;
	   }

	   ++count;
	   for(int i=0;i<5;++i) {
	     if(min[i]>test[i]) min[i]=test[i];
	     if(min[i]>0) M.C.STATUS0[i]=+1;
	     if(min[i]<0) M.C.STATUS0[i]=-1;
	     if((min[i]<0)&&(min[i]>-Math.pow(10,-15))) M.C.STATUS0[i]=2;
	   }
	   M.C.repaint();
	   M.P.repaint();
	}
	System.out.println("done "+count2+" "+count);
    }



    public double[] doTest() {
	double[] custom=new double[9];
	for(int i=0;i<7;++i) custom[i]=1.0*M.C.CUSTOM[i].val/512;
	Complex[] z=RandomCustom.main(custom); //config
	double s=getExponent();
	double min=1;
	double[][] d=Symmetrize.energyDiff(s,z);
	double[] test=sum(d);
	sendConfig(z);
	return test;
    }

    public double getExponent() {
	int s1=M.C.RANGE1.val;         
	int s2=M.C.RANGE2.val;  
	double t=Math.random();
	return (1-t)*s1+t*s2;
    }

    public double[] sum(double[][] d) {
	double[] s=splitSum(d);
	double[] ss={s[0]+s[1]+s[2]+s[3],s[0],s[1],s[2],s[3]};
	return ss;
    }


    /**Here are the various energies

            3
           2 0
            1

    (01)+(12)       base1
    (23)+(02)       base2
    (02)+(04)+(24)  bow1 
    (13)+(14)+(34)  bow2  
    */

    public double[] splitSum(double[][] d) {
	double base1=base1(d);
	double base2=base2(d);
	double bow1=bow1(d);
	double bow2=bow2(d);
	double[] s={base1,base2,bow1,bow2};
	return s;
    }

    public double base1(double[][] d) {
	return d[0][1]+d[1][2];
    }

    public double base2(double[][] d) {
	return d[0][3]+d[2][3];
    }

    public double bow1(double[][] d) {
	return d[0][2]+d[0][4]+d[2][4];
    }

    public double bow2(double[][] d) {
	return d[1][3]+d[1][4]+d[3][4];
    }

    public void sendConfig(Complex[] z) {
        for(int i=0;i<4;++i) {
           M.P.Z[i]=z[i];
	}
	M.P.repaint();
    } 


}
    
