import java.awt.*;

/**This is the file that does all the positive dominance tests*/

public class PolyTester {

    public static void main() {
	System.out.println("start");
	for(int i=0;i<16;++i) {
	    int[] A=selectSingle(i);
            Poly5 P=getPolyPreset(A[2],A[1],A[0]);
	    boolean TEST=Poly5.isPositiveDominant(P);
	    if(TEST==false) System.out.println(1/0);  //deliberate crash
	    if(TEST==true) System.out.println(i+" pass");
	}
	System.out.println("done");
    }

    /**This makes the polynomial associated to the preset domains*/

    public static Poly5 getPolyPreset(int i,int j,int k) {
       Poly5 P=new Poly5();
       if((i==0)&&(j==0)) P=PolyLemma1.hessianTrace(k);
       if((i==0)&&(j==1)) P=PolyLemma1.hessianDet(k);
       if((i==1)&&(j==0)) P=PolyLemma2.hessianTrace(k,94,13);
       if((i==1)&&(j==1)) P=PolyLemma2.hessianDet(k,94,13);
       return P;
    }

    /**This just turns an integer into the relevent list of indices*/
    public static int[] selectSingle(int t) {
        int t0=t%4;
	t=(t-t0)/4;
	int t1=t%2;
	t=(t-t1)/2;
	int t2=t%2;
	int[] A={t0,t1,t2};
	return A;
    }

}

